"use strict";

var _assert = _interopRequireDefault(require("assert"));

var _index = require("../index");

var _helper = _interopRequireDefault(require("./helper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var ERROR_PRESENCE = 'form.errors.presence';
var ERROR_EMAIL = 'form.errors.email';
describe('combine', function () {
  it('should combine validators', function () {
    _assert["default"].strictEqual(ERROR_PRESENCE, (0, _helper["default"])((0, _index.combine)((0, _index.required)(), (0, _index.email)())('')));

    _assert["default"].strictEqual(ERROR_EMAIL, (0, _helper["default"])((0, _index.combine)((0, _index.required)(), (0, _index.email)())('foo')));

    _assert["default"].ok(!(0, _index.combine)((0, _index.confirmation)({
      field: 'pass.password'
    }))('foo', {
      pass: {
        password: 'foo'
      }
    }));

    _assert["default"].ok(!(0, _index.combine)((0, _index.required)(), (0, _index.email)())('foo@bar.net'));
  });
});